<template>
  <div class="fr-container--fluid">
    <AtomAlert
      v-if="error"
      :alert-type="AlertType.Error"
      message="La liste des documents du bénéficiaire n'a pas pu être chargée."
    />
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <div
      v-else-if="documents"
      class="fr-grid-row fr-grid-row--gutters"
    >
      <div class="fr-col-12 fr-col-lg-9 fr-container--fluid">
        <BeneficiaryDocumentsList
          :documents="documents"
          :unread-notifications="unreadDocumentNotifications"
          @document-deleted="onDocumentDeleted"
          @document-edited="onDocumentEdited"
        />
      </div>
      <div class="fr-col-12 fr-col-lg-3">
        <BeneficiaryDocumentAdd
          :beneficiary-id="beneficiaryId"
          align-right
          @added="onDocumentAdded"
        />
      </div>
    </div>
  </div>
</template>

<script setup>
  import { generateNewEmptyDocumentList } from '~/utils'
  import { getRandomId } from '~/utils/random'
  import { AlertType } from '~~/utils/constants/alert'
  import { BeneficiaryTab } from '~~/utils/constants/beneficiary-tabs'

  const { $snackbar, $loadBeneficiaryDocuments, $getItems, $focusAndScrollTo } =
    useNuxtApp()
  const route = useRoute()

  const props = defineProps({
    beneficiaryId: { type: String, required: true }
  })

  const {
    data: documents,
    pending,
    error
  } = useLazyAsyncData(getRandomId('documents'), loadDocuments, {
    server: false
  })

  const { data: unreadDocumentNotifications } = useLazyAsyncData(
    getRandomId(`unreadDocumentNotifications`),
    loadUnreadDocumentNotifications,
    { server: false, default: () => [] }
  )

  watch(
    [pending, error, () => route.query.tab, () => route.query.item],
    async ([_pending, _error, tab, item]) => {
      if (_pending || _error) return

      await nextTick()

      if (tab === BeneficiaryTab.Documents && item) {
        $focusAndScrollTo(`#document-${item}`)
      }
    },
    { deep: true }
  )

  async function loadDocuments() {
    const _documents = await $loadBeneficiaryDocuments(props.beneficiaryId)

    const documentsByType = generateNewEmptyDocumentList()
    _documents.forEach(document => {
      documentsByType[document.document_type].push(document)
    })
    return documentsByType
  }

  function onDocumentAdded(document) {
    $snackbar.success('Le document a été ajouté avec succès.')
    addDocumentToDocuments(document)
  }

  function onDocumentDeleted({ documentId, documentType }) {
    $snackbar.success('Le document a été supprimé avec succès.')
    removeDocumentFromDocuments(documentType, documentId)
  }

  function onDocumentEdited({ documentType, document }) {
    $snackbar.success('Le document a été modifié avec succès.')
    if (documentType !== document.document_type) {
      removeDocumentFromDocuments(documentType, document.id)
      addDocumentToDocuments(document)
    } else {
      const documentIndex = documents.value[documentType].findIndex(
        ({ id }) => id === document.id
      )
      // Uses splice so the documents is correctly re-rendered in the template
      documents.value[documentType].splice(documentIndex, 1, document)
    }
  }

  function addDocumentToDocuments(document) {
    const documentTypeList = documents.value[document.document_type]
    documentTypeList.unshift(document)
  }

  function removeDocumentFromDocuments(documentType, documentId) {
    documents.value[documentType] = documents.value[documentType].filter(
      ({ id }) => id !== documentId
    )
  }

  async function loadUnreadDocumentNotifications() {
    const query = {
      fields: 'item.item.id',
      filter: {
        item: {
          'item:directus_files': {
            beneficiary: { id: { _eq: props.beneficiaryId } }
          }
        },
        read: { _eq: false }
      }
    }

    const res = await $getItems('notifications', query)

    if (res.status === 200) {
      return res.data.data.map(({ item }) => item[0].item.id)
    }
    throw new Error(errorResponseMessage(res))
  }
</script>
